create procedure run_query01 (in directory varchar, in personid varchar, in firstname varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query1.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Name@',  firstname);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query01_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, firstname varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_1_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"NAME"')
	     firstname := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query01(directory, personid, firstname);
}


create procedure run_query02 (in directory varchar, in personid varchar, in date0 varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query2.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Date0@',  date0);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query02_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, date0 varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_2_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"DATE0"')
	     date0 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query02(directory, personid, date0);
}


create procedure run_query03 (in directory varchar, in personid varchar, in date0 varchar,
       		 	      in duration varchar, in country1 varchar, in country2 varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query3.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Date0@',  date0);
  query_text := replace(query_text, '@Duration@',  duration);
  query_text := replace(query_text, '@Country1@',  country1);
  query_text := replace(query_text, '@Country2@',  country2);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query03_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, date0, duration, country1, country2 varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_3_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"DURATION"')
	     duration := vec[j+1];
    	  if (vec[j] = '"COUNTRY1"')
	     country1 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"COUNTRY2"')
	     country2 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"DATE0"')
	     date0 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query03(directory, personid, date0, duration, country1, country2);
}


create procedure run_query04 (in directory varchar, in personid varchar, in date0 varchar,
       		 	      in duration varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query4.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Date0@',  date0);
  query_text := replace(query_text, '@Duration@',  duration);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query04_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, date0, duration varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_4_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"DURATION"')
	     duration := vec[j+1];
    	  if (vec[j] = '"DATE0"')
	     date0 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query04(directory, personid, date0, duration);
}


create procedure run_query05 (in directory varchar, in personid varchar, in date0 varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query5.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Date0@',  date0);


  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query05_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, date0 varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_5_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"DATE0"')
	     date0 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query05(directory, personid, date0);
}

create procedure run_query06 (in directory varchar, in personid varchar, in tag varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query6.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Tag@',  tag);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query06_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, tag varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_6_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"TAG"')
	     tag := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query06(directory, personid, tag);
}

create procedure run_query07 (in directory varchar, in personid varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query7.txt');
  query_text := replace(query_text, '@Person@', personid);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query07_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_7_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query07(directory, personid);
}



create procedure run_query08 (in directory varchar, in personid varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query8.txt');
  query_text := replace(query_text, '@Person@', personid);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query08_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_8_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query08(directory, personid);
}


create procedure run_query09 (in directory varchar, in personid varchar, in date0 varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query9.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Date0@',  date0);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query09_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, date0 varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_9_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"DATE0"')
	     date0 := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query09(directory, personid, date0);
}

create procedure run_query10 (in directory varchar, in personid varchar,
       		 	      in hs0 varchar, in hs1 varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query10.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@HS0@',  hs0);
  query_text := replace(query_text, '@HS1@',  hs1);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query10_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, hs0, hs1 varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_10_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"HS0"')
	     hs0 := vec[j+1];
    	  if (vec[j] = '"HS1"')
	     hs1 := vec[j+1];
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query10(directory, personid, hs0, hs1);
}

create procedure run_query11 (in directory varchar, in personid varchar, in date0 varchar,
       		 	      in country varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query11.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@Date0@',  date0);
  query_text := replace(query_text, '@Country@',  country);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query11_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, date0, country varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_11_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"COUNTRY"')
	     country := replace(vec[j+1], '"', '');
    	  if (vec[j] = '"DATE0"')
	     date0 := vec[j+1];
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query11(directory, personid, date0, country);
}


create procedure run_query12 (in directory varchar, in personid varchar, in tagtype varchar)
{
  declare query_text any;
  query_text := file_to_string (directory || '/query12.txt');
  query_text := replace(query_text, '@Person@', personid);
  query_text := replace(query_text, '@TagType@',  tagtype);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  return rows;
}

create procedure run_query12_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare personid, tagtype varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_12_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"TAGTYPE"') {
	     tagtype := replace(vec[j+1], '"', '');
	  }
    	  if (vec[j] = '"PERSONID"')
	     personid := vec[j+1];
    	  j := j + 2;
    }
    return run_query12(directory, personid, tagtype);
}

create procedure run_query13 (in directory varchar, in person1 varchar, in person2 varchar)
{
  -- TODO: Fix Q13
  declare exit handler for sqlstate '42000' {
  	dbg_obj_print('Problem with Q13');
	goto done;
  };

  declare query_text any;
  query_text := file_to_string (directory || '/query13.txt');
  query_text := replace(query_text, '@Person1@', person1);
  query_text := replace(query_text, '@Person2@', person2);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  done:
  return rows;
}

create procedure run_query13_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare person1id, person2id varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_13_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"PERSON1ID"')
	     person1id := vec[j+1];
    	  if (vec[j] = '"PERSON2ID"')
	     person2id := vec[j+1];
    	  j := j + 2;
    }
    return run_query13(directory, person1id, person2id);
}

create procedure run_query14 (in directory varchar, in person1 varchar, in person2 varchar)
{
  -- TODO: Fix Q14
  declare exit handler for sqlstate '42000' {
  	dbg_obj_print('Problem with Q14');
	goto done;
  };

  declare query_text any;
  query_text := file_to_string (directory || '/query14.txt');
  query_text := replace(query_text, '@Person1@', person1);
  query_text := replace(query_text, '@Person2@', person2);

  declare state, msg, descs, rows any;
  state := '00000';
  exec (query_text, state, msg, vector (), 0, descs, rows);

  if (state <> '00000')
    signal (state, msg);

  done:
  return rows;
}

create procedure run_query14_file (in directory varchar, inout file any, in parameter_dir varchar)
{
    declare person1id, person2id varchar;
    declare j integer;
    declare line, vec any;
    line := file_read_line (file);
    if (line = 0) {
	declare random int;
	random := rnd(24);
	file :=  file_open (parameter_dir || sprintf('/../%02d/query_14_param.txt', random));
	line := file_read_line (file);
    }
    line := replace(line, '{', '');
    line := replace(line, '}', '');
    line := replace(line, '\n', '');
    j := 0;
    vec := split_and_decode(replace(replace(line, ': ', '='), ', ', '&'), 1);
    while (j < length(vec)) {
    	  if (vec[j] = '"PERSON1ID"')
	     person1id := vec[j+1];
    	  if (vec[j] = '"PERSON2ID"')
	     person2id := vec[j+1];
    	  j := j + 2;
    }
    return run_query14(directory, person1id, person2id);
}

create procedure run_person_view_1(in personid int, in probability int, in step int,
       		 		   in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_person_view_1 - ', personid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();
  
  exec ('person_view_1(?) --Q21', state, msg, vector (personid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  return rows;
}

create procedure run_person_view_2(in personid int, in probability int, in step int,
       		 		   in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_person_view_2 - ', personid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();
  
  exec ('person_view_2(?) --Q22', state, msg, vector (personid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  declare fs int;
  fs := 0;
  while (fs < length(rows) and fs < nbr_of_post_view_perq) {
     run_post_view_1(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_post_view_2(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_post_view_3(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_post_view_4(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     if (rows[0][4] is not null) {
     	run_post_view_1(rows[fs][4], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_2(rows[fs][4], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_3(rows[fs][4], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_4(rows[fs][4], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     }
     fs := fs + 1;
  }

  fs := 0;
  while (fs < length(rows) and fs < nbr_of_pers_view_perq) {
     if (rows[0][5] is not null) {
     	run_person_view_1(rows[fs][5], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][5], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][5], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     }
     fs := fs + 1;
  }

  return rows;
}

create procedure run_person_view_3(in personid int, in probability int, in step int,
       		 		   in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_person_view_3 - ', personid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();
  
  exec ('person_view_3(?) --Q23', state, msg, vector (personid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  declare fs int;
  fs := 0;
  while (fs < length(rows) and fs < nbr_of_pers_view_perq) {
  	run_person_view_1(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
  }

  return rows;
}

create procedure run_post_view_1(in postid int, in probability int, in step int,
       		 		 in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_post_view_1 - ', postid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();

  exec ('post_view_1(?) --Q31', state, msg, vector (postid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  return rows;
}

create procedure run_post_view_2(in postid int, in probability int, in step int,
       		 		 in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_post_view_2 - ', postid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();

  exec ('post_view_2(?) --Q32', state, msg, vector (postid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  declare fs int;
  fs := 0;
  while (fs < length(rows) and fs < nbr_of_pers_view_perq) {
  	run_person_view_1(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
  }

  return rows;
}

create procedure run_post_view_3(in postid int, in probability int, in step int,
       		 		 in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_post_view_3 - ', postid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();

  exec ('post_view_3(?) --Q33', state, msg, vector (postid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  declare fs int;
  fs := 0;
  while (fs < length(rows) and fs < nbr_of_pers_view_perq) {
  	run_person_view_1(rows[fs][2], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][2], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][2], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
  }

  return rows;
}

create procedure run_post_view_4(in postid int, in probability int, in step int, 
       		 		 in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int)
{
  --dbg_obj_print('run_post_view_4 - ', postid, ' - ', probability);
  declare state, msg, descs, rows any;
  state := '00000';

  declare random int;
  random := rnd(100);

  if (random >= probability)
    return vector();

  exec ('post_view_4(?) --Q34', state, msg, vector (postid), vector ('use_cache', 1), descs, rows);

  if (state <> '00000')
    signal (state, msg);

  if (rows = 0)
    return vector();

  declare fs int;
  fs := 0;
  while (fs < length(rows) and fs < nbr_of_post_view_perq) {
     run_post_view_1(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_post_view_2(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_post_view_3(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_post_view_4(rows[fs][0], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     fs := fs + 1;
  }

  fs := 0;
  while (fs < length(rows) and fs < nbr_of_pers_view_perq) {
     run_person_view_1(rows[fs][2], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_person_view_2(rows[fs][2], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     run_person_view_3(rows[fs][2], probability - step, step, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     fs := fs + 1;
  }

  return rows;
}

create procedure run_queries (in query_dir varchar,
       inout f1 any, inout f2 any, inout f3 any, inout f4 any, inout f5 any, inout f6 any, inout f7 any,
       inout f8 any, inout f9 any, inout f10 any, inout f11 any, inout f12 any, inout f13 any, inout f14 any,
       in i1 int, in i2 int, in i3 int, in i4 int, in i5 int, in i6 int, in i7 int,
       in i8 int, in i9 int, in i10 int, in i11 int, in i12 int, in i13 int, in i14 int,
       in initial_probability int, in step_probability int, in nbr_of_pers_view_perq int, in nbr_of_post_view_perq int,
       in parameter_dir varchar) 
{

  declare r, i integer;
  declare rows any;

  -- Q1
  i := 0;
  r := rnd(1000);
  while (i < (i1 / 1000) + (case when r < mod(i1, 1000) then 1 else 0 end)) {
     rows := run_query01_file(query_dir, f1, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q2
  i := 0;
  r := rnd(1000);
  while (i < i2 / 1000 + (case when r < mod(i2, 1000) then 1 else 0 end)) {
     rows := run_query02_file(query_dir, f2, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     fs := 0;
     while (fs < length(rows) and fs < 2) {
  	run_post_view_1(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_2(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_3(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_4(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }


  -- Q3
  i := 0;
  r := rnd(1000);
  while (i < i3 / 1000 + (case when r < mod(i3, 1000) then 1 else 0 end)) {
     rows := run_query03_file(query_dir, f3, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q4
  i := 0;
  r := rnd(1000);
  while (i < i4 / 1000 + (case when r < mod(i4, 1000) then 1 else 0 end)) {
     rows := run_query04_file(query_dir, f4, parameter_dir);
     i := i + 1;
  }

  -- Q5
  i := 0;
  r := rnd(1000);
  while (i < i5 / 1000 + (case when r < mod(i5, 1000) then 1 else 0 end)) {
     rows := run_query05_file(query_dir, f5, parameter_dir);
     i := i + 1;
  }

  -- Q6
  i := 0;
  r := rnd(1000);
  while (i < i6 / 1000 + (case when r < mod(i6, 1000) then 1 else 0 end)) {
     rows := run_query06_file(query_dir, f6, parameter_dir);
     i := i + 1;
  }

  -- Q7
  i := 0;
  r := rnd(1000);
  while (i < i7 / 1000 + (case when r < mod(i7, 1000) then 1 else 0 end)) {
     rows := run_query07_file(query_dir, f7, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     fs := 0;
     while (fs < length(rows) and fs < 2) {
  	run_post_view_1(rows[fs][5], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_2(rows[fs][5], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_3(rows[fs][5], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_4(rows[fs][5], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q8
  i := 0;
  r := rnd(1000);
  while (i < i8 / 1000 + (case when r < mod(i8, 1000) then 1 else 0 end)) {
     rows := run_query08_file(query_dir, f8, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     fs := 0;
     while (fs < length(rows) and fs < 2) {
  	run_post_view_1(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_2(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_3(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_4(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q9
  i := 0;
  r := rnd(1000);
  while (i < i9 / 1000 + (case when r < mod(i9, 1000) then 1 else 0 end)) {
     rows := run_query09_file(query_dir, f9, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     fs := 0;
     while (fs < length(rows) and fs < 2) {
  	run_post_view_1(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_2(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_3(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_post_view_4(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q10
  i := 0;
  r := rnd(1000);
  while (i < i10 / 1000 + (case when r < mod(i10, 1000) then 1 else 0 end)) {
     rows := run_query10_file(query_dir, f10, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][3], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q11
  i := 0;
  r := rnd(1000);
  while (i < i11 / 1000 + (case when r < mod(i11, 1000) then 1 else 0 end)) {
     rows := run_query11_file(query_dir, f11, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][4], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q12
  i := 0;
  r := rnd(1000);
  while (i < i12 / 1000 + (case when r < mod(i12, 1000) then 1 else 0 end)) {
     rows := run_query12_file(query_dir, f12, parameter_dir);
     declare fs int;
     fs := 0;
     while (fs < length(rows) and fs < 1) {
  	run_person_view_1(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_2(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
     	run_person_view_3(rows[fs][0], initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq);
	fs := fs + 1;
     }
     i := i + 1;
  }

  -- Q13
  i := 0;
  r := rnd(1000);
  while (i < i13 / 1000 + (case when r < mod(i13, 1000) then 1 else 0 end)) {
     rows := run_query13_file(query_dir, f13, parameter_dir);
     i := i + 1;
  }

  -- Q14
  i := 0;
  r := rnd(1000);
  while (i < i14 / 1000 + (case when r < mod(i14, 1000) then 1 else 0 end)) {
     rows := run_query14_file(query_dir, f14, parameter_dir);
     i := i + 1;
  }

}

create procedure nothing()
{
  return;
}

create procedure run_benchmark (in update_stream_path varchar, in query_dir varchar, in parameter_dir varchar, in stream int)
{
  declare f any;
  declare line any;
  declare ln any;
  declare ind integer;
  declare run_reads integer;
  declare run_updates integer;

  declare f1, f2, f3, f4, f5, f6, f7, f8, f9, f10, f11, f12, f13, f14 any;
  f1 := file_open (parameter_dir || '/query_1_param.txt');
  f2 := file_open (parameter_dir || '/query_2_param.txt');
  f3 := file_open (parameter_dir || '/query_3_param.txt');
  f4 := file_open (parameter_dir || '/query_4_param.txt');
  f5 := file_open (parameter_dir || '/query_5_param.txt');
  f6 := file_open (parameter_dir || '/query_6_param.txt');
  f7 := file_open (parameter_dir || '/query_7_param.txt');
  f8 := file_open (parameter_dir || '/query_8_param.txt');
  f9 := file_open (parameter_dir || '/query_9_param.txt');
  f10 := file_open (parameter_dir || '/query_10_param.txt');
  f11 := file_open (parameter_dir || '/query_11_param.txt');
  f12 := file_open (parameter_dir || '/query_12_param.txt');
  f13 := file_open (parameter_dir || '/query_13_param.txt');
  f14 := file_open (parameter_dir || '/query_14_param.txt');

  declare i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14 integer;
  declare initial_probability, step_probability, nbr_of_pers_view_perq, nbr_of_post_view_perq integer;
  i1 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query1perUpdate') as int);
  i2 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query2perUpdate') as int);
  i3 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query3perUpdate') as int);
  i4 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query4perUpdate') as int);
  i5 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query5perUpdate') as int);
  i6 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query6perUpdate') as int);
  i7 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query7perUpdate') as int);
  i8 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query8perUpdate') as int);
  i9 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query9perUpdate') as int);
  i10 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query10perUpdate') as int);
  i11 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query11perUpdate') as int);
  i12 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query12perUpdate') as int);
  i13 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query13perUpdate') as int);
  i14 := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'Query14perUpdate') as int);
  initial_probability := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'InitialProbability') as int);
  step_probability := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'StepProbability') as int);
  nbr_of_pers_view_perq := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'NbrOfPersViewsPerQ') as int);
  nbr_of_post_view_perq := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'NbrOfPostViewsPerQ') as int);
  run_reads := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'RunReads') as int);
  run_updates := cast (cfg_item_value(query_dir || '/ratio.ini', 'Parameters', 'RunUpdates') as int);

  log_enable (2, 1);
  set non_txn_insert = 1;

  f := file_open (update_stream_path);

  ind := 1;
  while (line := file_read_line (f))
    {
      ln := split_and_decode (line, 0, '\0\0|');
      ln[2] := subseq(ln[2], 1, length(ln[2]) - 1);
      if (ln[1] like 'ADD_PERSON') {
      	 if (run_updates = 1)
            add_person(ln[2]);
      }
      if (ln[1] like 'ADD_LIKE_POST') {
      	 if (run_updates = 1)
            add_like_post(ln[2]);
      }
      if (ln[1] like 'ADD_LIKE_COMMENT') {
      	 if (run_updates = 1)
            add_like_comment(ln[2]);
      }
      if (ln[1] like 'ADD_FORUM') {
      	 if (run_updates = 1)
            add_forum(ln[2]);
      }
      if (ln[1] like 'ADD_FORUM_MEMBERSHIP') {
      	 if (run_updates = 1)
            add_forum_membership(ln[2]);
      }
      if (ln[1] like 'ADD_POST') {
      	 if (run_updates = 1)
            add_post(ln[2]);
      	 if (run_reads = 1)
      	    run_queries(query_dir, f1, f2, f3, f4, f5, f6, f7, f8, f9, f10, f11, f12, f13, f14,
	    			   i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14,
	    		initial_probability, step_probability,
			nbr_of_pers_view_perq, nbr_of_post_view_perq,
			parameter_dir);
      }
      if (ln[1] like 'ADD_COMMENT') {
      	 if (run_updates = 1)
            add_comment(ln[2]);
      	 if (run_reads = 1)
     	    run_queries(query_dir, f1, f2, f3, f4, f5, f6, f7, f8, f9, f10, f11, f12, f13, f14,
	    			   i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14,
	    		initial_probability, step_probability,
			nbr_of_pers_view_perq, nbr_of_post_view_perq,
			parameter_dir);
      }
      if (ln[1] like 'ADD_FRIENDSHIP') {
      	 if (run_updates = 1)
            add_friendship(ln[2]);
      }
      if (run_reads = 1 and mod(ind, 100) = 0)
      	 dbg_obj_print('###', stream, '-', ind);
      if (run_reads = 0 and mod(ind, 1000) = 0)
      	 dbg_obj_print('###', stream, '-', ind);
      ind := ind + 1;
    }
}
