

create table ql_staging (
ql_id int primary key identity, 
       ql_q varchar,
       ql_start_dt      datetime,
       ql_rt_msec       int,
       ql_text            LONG VARCHAR,
       ql_plan                    LONG VARCHAR
);


insert into ql_staging (ql_id, ql_q, ql_text, ql_plan, ql_rt_msec, ql_start_dt) 
select ql_id, regexp_substr ('Q[0-9]*', cast (ql_text as varchar), 0) , ql_text, ql_plan, ql_rt_msec, ql_start_dt from sys_query_log;

);



select ql_q, avg (ql_rnd_rows), avg (ql_seq_rows), (sum (ql_same_seg) * 100.0) / sum (ql_rnd_rows) s  from ql_staging s, sys_query_log l where s.ql_id =  l.ql_id and ql_rnd_rows > 0 group by ql_q order by 2 desc;

select  regexp_substr ('Q[0-9]*', cast (ql_text as varchar), 0) as q, sum (ql_c_clocks) / 2.3e9 from sys_query_log group by q order by 2 desc;

select  regexp_substr ('Q[0-9]*', cast (ql_text as varchar), 0) as q, avg (ql_c_clocks) / 2.3e9 from sys_query_log where ql_start_dt > {ts '2013-10-5 10:00'} group by q order by 2 desc;



select ql_q, count (distinct ql_plan_hash) from ql_staging  s, sys_query_log l where s.ql_id = l.ql_id group by ql_q order by 2 desc;



set blobs on;

select ql_q, ql_rt_msec, ql_text, ql_plan   from ql_staging q1
       where ql_rt_msec = (select min (ql_rt_msec) from ql_staging q2 where  q1.ql_q = q2.ql_q)
or ql_rt_msec = (select max (ql_rt_msec) from ql_staging q2 where  q1.ql_q = q2.ql_q)
order by ql_q, ql_rt_msec;

